using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;   // For the DllImport of TcC Driver API

namespace TcCNet
{
	public class TcC
	{
		// Prototype TcC.dll function in managed C# for Dot Net
		// Using C# data types and default marshaling of unmanaged code

		[UnmanagedFunctionPointer(CallingConvention.Cdecl)]
		public delegate void TScanVCallback(IntPtr pData, UInt32 DataSize);

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
		public static extern UInt32 TcC_Convert([In] UInt64[] pRawData, UInt32 RawDataCount, [Out] Double[] pResult, UInt32 ResultCount, Double ExtraGain, [In] Byte[] pConfig, UInt32 ConfigBytes);

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
		public static extern UInt32 TcC_StartAcquisition(Byte TcRange, Byte CJCRange, Byte Oversample, double AcqHz, UInt32 BufferSize, UInt32 BaseBufferCount, ref TScanVCallback pCallback);

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
		public static extern UInt32 TcC_StopAcquisition;

	}
}

